import numpy as np

inf = float('Inf')

costos = np.array([[inf, 1, 3, 4, 3],
				    [1, inf, 2, 2, 4],
				    [3, 2, inf, 5, 5], 
				    [4, 2, 5, inf, 6], 
				    [3, 4, 5, 6, inf]] )


def min_index(matriz):
	# Busca el minimo en una matriz y devuelve la fila y la columna
	u,v = np.unravel_index(matriz.argmin(), matriz.shape)
	return u,v

def diff(A, B):
	# Devuelve los elementos de A que no estan en B
	B = set(B)
	return [aa for aa in A if aa not in B]
	
def submatriz(matriz,ind_1,ind_2):
	# Genera una submatriz con ind_1 filas e ind_2 columnas
	return matriz[np.ix_(ind_1,ind_2)]	
	
def ordenar_matriz(matriz):
	# Ordenar la matriz y guardar vector de permutaciones
	vect=matriz.reshape(-1)
	perm=sorted(range(len(vect)), key=lambda k: vect[k])	
	return perm

def coord_matriz_ordenada( matriz, perm, i ):
	# Devuelve la fila y la columna del elemento numero i.
	u,v = np.unravel_index(perm[i], matriz.shape)
	return u,v
	
	

		
		
		



	
	
